﻿using System.Diagnostics;

namespace Exam
{
    public class PipeInspection
    {
        public string[] pipeInfo;
        public string[,] Defective;
        public double allves;


        /// <summary>
        /// Метод для получения информации из файла
        /// </summary>
        /// <param name="fileName">путь к файлу из которого получена информация</param>
        public void getPipeInfo(string fileName)
        {
            allves = 0;
            pipeInfo = File.ReadAllLines(fileName);
            Defective = new string[pipeInfo.Length, 5];
            for (int i = 0; i < pipeInfo.Length; i++)
            {
                string[] info = pipeInfo[i].Split(";");//разбиение строки на подстроки разделенные ";"
                for (int j = 0; j < info.Length; j++)
                {
                    if (info.Length == 5)
                    {
                        Defective[i, 4] = "n";//добавление в места где отсусвует литерал значения н сокращение от none
                    }
                    Defective[i, j] = info[j];

                }
                Debug.WriteLine("Строка " + (i + 1) + " разбита на подстроки");
            }

        }

        /// <summary>
        /// Метод для вывода исходных данных
        /// </summary>
        public void present()
        {

            Console.WriteLine("Исходные данные");
            getPipeInfo(@"Z:\Преподаватели\МухинНА\ПМ 02 вариант 3\data.txt");
            for (int i = 0; i < pipeInfo.Length; i++)
            {
                Console.Write("Вид трубы: " + Defective[i, 0]);
                Console.Write("  Длина трубы: " + Defective[i, 1]);
                Console.Write("  Внешний диаметр трубы: " + Defective[i, 2]);
                Console.Write("  Толщина стенки трубы: " + Defective[i, 3]);
                Console.Write("  Артикул трубы: " + Defective[i, 4]);
                Console.WriteLine();
            }
        }

  
        /// <summary>
        /// Метод для подсчета веса трубы
        /// </summary>
        /// <param name="defect"> Труба по которой проходит подсчет веса</param>
        public void ves (string[] defect)
        {
            double vesTr;
            Console.Write("Вид трубы: " + defect[0]);
            Console.Write("  Длина трубы: " + defect[1]);
            Console.Write("  Внешний диаметр трубы: " + defect[2]);
            Console.Write("  Толщина стенки трубы: " + defect[3]);
            Console.Write("  Артикул трубы: " + defect[4]);
            Console.WriteLine();
            double r = (Convert.ToDouble(defect[2]) - Convert.ToDouble(defect[3])) / 2;
            double s = Math.PI * Math.Pow(r, 2);
            double vol = s * Convert.ToDouble(defect[1]) * 0.001;
            if (defect[4] == "A")
            {
                vesTr = vol * 1.24;
            }
            else
            {
                vesTr = vol * 0.91;
             }
            allves += vesTr;
            Console.WriteLine("Вес трубы  =" + vesTr/1000+" кг");
            Debug.WriteLine(vesTr);
        }

        /// <summary>
        /// Метод для проверки на дефективность трубы
        /// </summary>
        /// <param name="defect">массив с данными о той или иной трубе </param>
        /// <returns> возвращаемое булевое значение для дальнейшей работы с ним</returns>
        public bool DefectiveSearch(string[] defect)
        {
            Console.Write("Вид трубы: " + defect[0]);
            Console.Write("  Длина трубы: " + defect[1]);
            Console.Write("  Внешний диаметр трубы: " + defect[2]);
            Console.Write("  Толщина стенки трубы: " + defect[3]);
            Console.Write("  Артикул трубы: " + defect[4]);

            if ((Convert.ToDouble(defect[1]) >= 3960 && Convert.ToDouble(defect[1]) <= 4040))
            {
                if (((Convert.ToDouble(defect[2]) <= 20.2 && Convert.ToDouble(defect[2]) >= 19.8)) || (Convert.ToDouble(defect[2]) <= 25.25 && Convert.ToDouble(defect[2]) >= 24.75) || (Convert.ToDouble(defect[2]) >= 31.68 && Convert.ToDouble(defect[2]) <= 32.32) || (Convert.ToDouble(defect[2]) >= 39.6 && Convert.ToDouble(defect[2]) <= 40.4) || (Convert.ToDouble(defect[2]) <= 50.5 && Convert.ToDouble(defect[2]) >= 49.5) || (Convert.ToDouble(defect[2]) >= 62.37 && Convert.ToDouble(defect[2]) <= 63.63))

                {
                    if (defect[0] == "PN10" && (Convert.ToDouble(defect[1]) >= 3960 && Convert.ToDouble(defect[1]) <= 4040) && (Convert.ToDouble(defect[3]) >= ((Convert.ToDouble(defect[2]) / 100) * 10) && Convert.ToDouble(defect[3]) <= ((Convert.ToDouble(defect[2]) / 100) * 11)))
                    {
                        return true;
                    }
                    else
                    if (defect[0] == "PN16" && (Convert.ToDouble(defect[1]) >= 3960 && Convert.ToDouble(defect[1]) <= 4040) && (Convert.ToDouble(defect[3]) >= ((Convert.ToDouble(defect[2]) / 100) * 13.5) && Convert.ToDouble(defect[3]) <= ((Convert.ToDouble(defect[2]) / 100) * 14)))
                    {
                        return true;
                    }
                    else
                    if (defect[0] == "PN20" && (Convert.ToDouble(defect[3]) >= ((Convert.ToDouble(defect[2]) / 100) * 16.5) && Convert.ToDouble(defect[3]) <= ((Convert.ToDouble(defect[2]) / 100) * 17)))
                    {
                        return true;
                    }
                    else
                    if (defect[0] == "PN25" && (Convert.ToDouble(defect[3]) >= ((Convert.ToDouble(defect[2]) / 100) * 16.5) && Convert.ToDouble(defect[3]) <= ((Convert.ToDouble(defect[2]) / 100) * 17)))
                    {
                        return true;
                    }
                    else
                    {
                        Console.Write("Брак по толщине ");
                    }
                }
                else
                {
                    Console.Write("Брак по диаметру ");
                }
            }
            else
            {
                Console.Write("Брак по длине ");
            }

            return false;
        }
    }
}
